package info.kwarc.sally4.servlet.impl;

import info.kwarc.sally4.core.CamelContextProvider;
import info.kwarc.sally4.servlet.SallyServlet;

import javax.servlet.ServletException;

import org.apache.camel.component.servlet.CamelHttpTransportServlet;
import org.apache.camel.component.servlet.ServletComponent;
import org.apache.felix.ipojo.annotations.Component;
import org.apache.felix.ipojo.annotations.Instantiate;
import org.apache.felix.ipojo.annotations.Invalidate;
import org.apache.felix.ipojo.annotations.Provides;
import org.apache.felix.ipojo.annotations.Requires;
import org.apache.felix.ipojo.annotations.Validate;
import org.osgi.service.http.HttpService;
import org.osgi.service.http.NamespaceException;

@Component
@Provides
@Instantiate
public class ServletImpl implements SallyServlet {

	@Requires
	HttpService httpSevlet;

	@Requires
	CamelContextProvider camelContextProvider;

	@Validate
	public void start() throws ServletException, NamespaceException {
		CamelHttpTransportServlet srvlet = new CamelHttpTransportServlet();
		httpSevlet.registerServlet("/sally", srvlet, null, null);
		ServletComponent servletComponent = new ServletComponent();
		servletComponent.setServletName(srvlet.getServletName());
		camelContextProvider.registerGlobalComponent("sallyservlet", servletComponent);
	}

	@Invalidate
	public void stop() {
		httpSevlet.unregister("/sally");		
		camelContextProvider.unregisterGlobalComponent("sallyservlet");
	}

}
